%{

#include "parse.tab.h"  
#include "vars.h"       


%}
%option	yylineno

WHITE			[ \t\n]+
LETTER                  [A-Za-z]
DIGIT                   [0-9]
INTEGER                 {DIGIT}+
INTOREMPTY              {DIGIT}*
REAL		        [+-]?{INTOREMPTY}("."{INTOREMPTY})?
ID                      {LETTER}({LETTER}|{DIGIT})*
%%
"#"[^\n]*		{} // eat up one-line comments starting with #
{WHITE}			{}
"directory"		{ return(DIRECTORY); }
"use"			{ return USE; }
"seed"			{ return SEED; }
"serial"		{ return SERIAL; }
"create"		{ return CREATE; }
"grade"			{ return GRADE; }
"from"			{ return FROM; }
"to"			{ return TO; }
"scale"			{ return SCALE; }
{INTEGER}	 	{ yylval.i = atoi(yytext); return INTEGER; }	
{REAL}			{ yylval.d = atof(yytext); return REAL; }	
{ID}			{ yylval.p = strdup(yytext); return ID; }
\"[^\"\n]*\"		{ yylval.p = strdup(yytext)+1; yylval.p[strlen(yylval.p)-1]=0; return STRING; } 
<<EOF>>			{ fprintf(llog, "scanner: read %d lines\n", yylineno); yyterminate(); }
;			{ return ';'; }
%%
yywrap()
{ return(1); }
