
#include        <stdio.h>
#include	<ctype.h>
#include        <string.h>
#include        <locale.h>
#include        <fnmatch.h>
#include        <dirent.h>
#include        <stdlib.h>
#include        <math.h>

#include	"randomlib.h"

#ifdef MAIN_PROGRAM
 #define EXTERN	/**/
#else
 #define EXTERN extern
#endif

#define	MAX_FNAME_LENGTH	10000
#define	MAX_STR_LENGTH	1000
#define	MAX_NAME	40
#define	MAX_STUDENTS	1000
#define	MAX_RULES	2000
#define	MAX_QUESTIONS_PER_PAPER	80
#define	MAX_QUESTION_TYPES	40
#define	MAX_QUESTIONS_PER_TYPE	100

// how to grade a test with a given serial number
typedef	struct rule {
	int	serial;		// serial number of test
	char	correct[MAX_QUESTIONS_PER_PAPER];	// correct answers
	double	penalty[MAX_QUESTIONS_PER_PAPER];	// penalties for each wrong answer
	double	rescale;				// rescale the score by
} rule;

// student data
typedef	struct	student {
	char	descr[MAX_STR_LENGTH]; // name, dept, etc
	int	serial;		// serial number of student's test
	char	ans[MAX_QUESTIONS_PER_PAPER];	// student's answer string
	char	correct[MAX_QUESTIONS_PER_PAPER];	// correct answer string corresponding to student's serial number
	double	grade;		// student's grade for the test
} student;

// variables for (f)lex
extern	int	yylineno;
extern	FILE	*yyin;

// File names

// Base directory
EXTERN	char	basedir[MAX_FNAME_LENGTH]
#ifdef MAIN_PROGRAM
="."
#endif
;

// name of log file
EXTERN	char	log_fname[MAX_FNAME_LENGTH]
#ifdef MAIN_PROGRAM
="mc-logfile"
#endif
;

// name of output TeX file
EXTERN	char	output_fname[MAX_FNAME_LENGTH]
#ifdef MAIN_PROGRAM
="mc-output.tex"
#endif
;

// name of file which contains information about the serial numbers used
EXTERN	char	serial_fname[MAX_FNAME_LENGTH]
#ifdef MAIN_PROGRAM
="mc-serials.txt"
#endif
;

// name of file containing the correct answers per serial number
EXTERN	char	announce_fname[MAX_FNAME_LENGTH]
#ifdef MAIN_PROGRAM
="correct-answers.txt"
#endif
;

// name of file containing all questions in the database
EXTERN	char	all_fname[MAX_FNAME_LENGTH]
#ifdef MAIN_PROGRAM
="mc-all-questions.tex"
#endif
;

// name of file containing all given answers
EXTERN	char	papers_fname[MAX_FNAME_LENGTH]
#ifdef MAIN_PROGRAM
="papers"
#endif
;

// name of file containing all grades
EXTERN	char	grades_fname[MAX_FNAME_LENGTH]
#ifdef MAIN_PROGRAM
="grades"
#endif
;

// file pointers
EXTERN	FILE	*out, *ser, *llog, *ann;

// name of test-description file 
EXTERN	char	test_fname[MAX_FNAME_LENGTH];

// first serial number to produce
EXTERN	int	first_serial
#ifdef MAIN_PROGRAM
=100
#endif
;

// how many papers to produce
EXTERN	int	num_papers
#ifdef MAIN_PROGRAM
=100
#endif
;

// strings to hold a lot of text for general use
EXTERN	char	line[10][10*MAX_STR_LENGTH];

//
//
// The question database
//
//

// how many question types
EXTERN	int	num_types
#ifdef	MAIN_PROGRAM
=0
#endif
;

// names of question types
EXTERN	char	type[MAX_QUESTION_TYPES][MAX_NAME];

// how many question instances per question type are required
EXTERN	int	num_per_type[MAX_QUESTION_TYPES];

// how many question instances per question type exist
EXTERN	int	existing_num_per_type[MAX_QUESTIONS_PER_TYPE];

// which are the questions in each type
EXTERN	char	question_fname[MAX_QUESTION_TYPES][MAX_QUESTIONS_PER_TYPE][MAX_NAME];

// how many questions per paper
EXTERN	int	questions_per_paper;

// random seed
EXTERN	int	seed
#ifdef	MAIN_PROGRAM
=1234
#endif
;

// the Latex strings used to label the answers
EXTERN	char	ans_name[][20]
#ifdef MAIN_PROGRAM
={"$A$", "$B$", "$C$", "$D$", "$E$", "$F$", "$G$", "$H$", "$J$", "$K$"}
#endif
;

EXTERN	char	letter[]
#ifdef	MAIN_PROGRAM
="ABCDEFGHIJKLMNOPQRSTUVWXYZ"
#endif
;

// program mode
EXTERN	int	mode// Create, Grade or Help
#ifdef	MAIN_PROGRAM
='C'
#endif
;

// maximum grade to scale to
EXTERN	double	maxgrade// Create, Grade or Help
#ifdef	MAIN_PROGRAM
=10.0
#endif
;
